<template>
  <div>
    <h1>주제 생성</h1>
    <el-row>
      <el-col style="max-width: 600px;">
        <el-form :model="input" ref="elForm" label-width="125px">
          <el-form-item label="주제 제목">
            <el-input v-model="title"></el-input>
          </el-form-item>

          <el-form-item label="공동 강사 목록">
            <!-- TODO: translation -->
            <el-input
              v-model="teacherEmailList"
              placeholder="공동 강사가 없을시 비워주세요.">
            </el-input>
          </el-form-item>

          <el-form-item label="주제 소개">
            <el-input type="textarea" :rows="3" v-model="description"></el-input>
          </el-form-item>

          <el-form-item label="주제 활성화 시각">
            <el-date-picker
              v-model="activeStartDate"
              type="datetime"
            >
            </el-date-picker>
          </el-form-item>

          <el-form-item label="주제 비활성화 시각">
            <el-date-picker
              v-model="activeEndDate"
              type="datetime"
              :disabled="!shouldDeactivated"
            >
            </el-date-picker>
            <el-radio-group v-model="shouldDeactivated" @change="changeShouldDeactivated">
              <el-radio-button :label="true">비활성화</el-radio-button>
              <el-radio-button :label="false">계속 활성화</el-radio-button>
            </el-radio-group>
          </el-form-item>

          <el-form-item>
            <!-- TODO: use button loading -->
            <el-button
              type="primary"
              :disabled="!isNewClassValid"
              @click="onSubmit"
            >
              세션 생성하기
            </el-button>
          </el-form-item>

        </el-form>
      </el-col>
    </el-row>
  </div>
</template>

<script>
import { mapMutations, mapState, mapActions, mapGetters } from 'vuex';
// import authService from '../../services/authService';
import utils from '../../utils';

export default {
  name: 'TeacherClassNew',
  // async mounted() {
  //   const res = await authService.test();
  //   console.log(res);
  // },
  data() {
    return {
      test: '',
      shouldDeactivated: true,
    };
  },
  methods: {
    ...mapMutations('class', [
      'updateNewClass',
      'assignNewClass',
    ]),
    ...mapActions('class', [
      'postClass',
    ]),
    changeShouldDeactivated(label) {
      const vm = this;
      if (!label) {
        vm.activeEndDate = null;
      }
    },
    async onSubmit() {
      const vm = this;
      try {
        await vm.postClass();
        vm.updateNewClass({
          newClass: {
            activeStartDate: null,
            activeEndDate: null,
          },
        });
        vm.$router.push('/a/teacher/class');
      } catch (error) {
        vm.$notify({
          title: vm.$t('NOTIFY.FAIL_CRE_SUBJ'),
          message: error.toString(),
          type: 'error',
          duration: 0,
        });
      }
    },
  },
  computed: {
    ...mapState('class', [
      'newClass',
    ]),
    ...mapGetters('class', [
      'isNewClassValid',
    ]),
    input() {
      const res = {};
      const vm = this;
      res.todo = vm.todo; // TODO: delete
      return res;
    },
    title: {
      get() {
        const vm = this;
        return vm.newClass.title;
      },
      set(title) {
        const vm = this;
        vm.assignNewClass({
          newClass: {
            title,
          },
        });
      },
    },
    teacherEmailList: {
      get() {
        const vm = this;
        if (!vm.newClass.teacherEmailList) {
          return null;
        }
        return vm.newClass.teacherEmailList.join(', ');
      },
      set(teacherEmailList) {
        const vm = this;
        vm.assignNewClass({
          newClass: {
            teacherEmailList: teacherEmailList.split(',')
              .map(value => value.trim())
              .filter(value => utils.isValidEmail(value)),
          },
        });
      },
    },
    description: {
      get() {
        const vm = this;
        return vm.newClass.description;
      },
      set(description) {
        const vm = this;
        vm.assignNewClass({
          newClass: {
            description,
          },
        });
      },
    },
    activeStartDate: {
      get() {
        const vm = this;
        // const activeStartDate = new Date(vm.newClass.activeStartDate);
        return vm.newClass.activeStartDate;
      },
      set(activeStartDate) {
        const vm = this;
        vm.assignNewClass({
          newClass: {
            activeStartDate,
          },
        });
      },
    },
    activeEndDate: {
      get() {
        const vm = this;
        return vm.newClass.activeEndDate;
      },
      set(activeEndDate) {
        const vm = this;
        vm.assignNewClass({
          newClass: {
            activeEndDate,
          },
        });
      },
    },
  },
};
</script>
